#!/usr/bin/env python
# 

import math; from math import factorial

n = 4
p1, p2, p3 = 0.5, 0.3, 0.2

print "%5s %5s %5s %10s %10s %10s %10s" % ("b1", "b2", "b3", "P(Q=q)", "q1", "q2", "q3")
n_samps = 0
for b1 in range(n+1):
    for b2 in range(n+1): 
        for b3 in range(n+1): 
            if b1+b2+b3 != n : continue 
            # we have sample from the multinomial distribution 
            p_sample = ( factorial(n) / (factorial(b1) * factorial(b2) * factorial(b3)) ) * p1**b1 * p2**b2 * p3**b3

            q1 = max( abs( float(b1)/n - p1 ), abs( float(b2)/n - p2 ), abs( float(b3)/n - p3 ) )
            q2 = ( float(b1)/n - p1 )**2 + ( float(b2)/n - p2 )**2 + ( float(b3)/n - p3 )**2
            q3 = abs( float(b1)/n - p1 ) + abs( float(b2)/n - p2 ) + abs( float(b3)/n - p3 )

            print "%5d %5d %5d %10.6f %10.6f %10.6f %10.6f" % (b1, b2, b3, p_sample, q1, q2, q3)
            
            n_samps += 1 

